#include<cdefBF527.h>
#include<ccblkfn.h>
#include <sysreg.h>
#include <stdio.h>

#include<sys/exception.h>

#define SystemCLK	 30000		//Value in KHz
#define VCO_CoreCLK  1			//Value of VCO/CCLK - value can be 1, 2, 4, 8
#define VCO			 200000		//Value in KHz
#define CLKin		 25000

	short tempJ = 0xFFFF;
	short tempJ1 = 0xffff;
	short tempJ2 = 0xffff;
	short tempJ3 = 0xffff;
	
short DummyRx[512];
short CommandBuffer[8][8];
short ResponseBuffer[17][8];
short FinalResponseBuffer[17];
short TransmitData[516][8];
short ReceiveData[517][8];
short FinalReceiveData[514];
section("sdcard") short DummyVar[512];
section("sdram0") short TestVar[512];
int DMADone = 0;
int NewRCA;
int CardDetected;
int Debounce = 0;
int cnt = 0;
//int tc1,tc2;

void SetUpDMATransmit(int NumberOfWords);
void SetUpInterruptsBF(void);
void ConfigureAsyncMem(void);
void SendCommand(int Command, int value);
void SetUpCommandArray(int Command, int value);
void SetUpClockSD(int NumberOfCycles);
void SetUpDMAReceive(int NumberOfWords);
void PLLSetupBF(void);
void ReceiveResponse(int Type);
void ReceiveCRC (int NumberOfWords);
void ReceiveRData (int NumberOfWords);
void ExtractResponse(void);
void ExtractData(void);
void SetUpTransmitData(void);
void SetUpDMADataTransmit(int NumberOfWords);
void SetUpDMADataReceive(int NumberOfWords);
void CardDetection(void);

EX_INTERRUPT_HANDLER (SDIsr);
EX_INTERRUPT_HANDLER (PFIsr);

void main()
{
	short tempvar;
	int i;
		
	PLLSetupBF();
	ConfigureAsyncMem();
	SetUpInterruptsBF();
	CardDetected = 0;
	CardDetection();
	while(!CardDetected);	
	SendCommand(0,0);
			
	do
    {	
	SendCommand(55,0);  	/*Tx - Send CMD 55 - Expect R1 response */
    ReceiveResponse(48);  	/*Rx - Receive R1 response */
    
    SendCommand(41, 0x00FF8000);
	ReceiveResponse(48);  	/*Rx - Receive R3 response */
	ExtractResponse();
	tempvar = FinalResponseBuffer[0] & 0x1;
	
	SetUpClockSD(1024);
	SetUpClockSD(1024);
	
	
	} while ((tempvar & 0x1) != 0x1);
	
	SendCommand(2,0);  /*Tx - Send CMD 2 - Expect R2 response */
    ReceiveResponse(136);  /*Rx - Receive R2 response */
    
    SendCommand(3,0);  /*Tx - Send CMD 3 - Expect R6 response */
    ReceiveResponse(48);  /*Rx - Receive R6 response */
    
    ExtractResponse();
    
    NewRCA = ((FinalResponseBuffer[0]<<15) | (FinalResponseBuffer[1] <<7) | FinalResponseBuffer[2] >> 1);
    
	SendCommand(9,((NewRCA<<16) & 0xFFFF0000));  /*Tx - Send CMD 9 - Expect R2 response */
    ReceiveResponse(136);  /*Rx - Receive R2 response */
    ExtractResponse();
    
    SendCommand(7,((NewRCA<<16) & 0xFFFF0000));  /*Tx - Send CMD 7 - Expect R1b response */
    ReceiveResponse(48);  /*Rx - Receive R1b response */
    
    for(i=1;i<513;i++)
    {
    	
        TransmitData[i][0] = i+5;
    }
    
    SetUpTransmitData();
    
    SendCommand(16,0);  //Tx - Send CMD 16 - Expect R1 response 
    ReceiveResponse(48);  //Rx - Receive R1 response 
    
    SendCommand(24,0);  //Tx - Send CMD 24 - Expect R1 response
    ReceiveResponse(48);  //Rx - Receive R1 response 
    
    
    SetUpDMADataTransmit(4121);
    while(!DMADone);
    DMADone = 0;
    
    ReceiveCRC(10);
    
    SendCommand(16,512);  //Tx - Send CMD 16 - Expect R1 response 
    ReceiveResponse(48);  //Rx - Receive R1 response 
    
    SendCommand(17,0);  /*Tx - Send CMD 17 - Expect R1 response */
    ReceiveRData(4160);
    
    ExtractData();
    
    while(1)
    {
    	asm("nop;");
    }
}

void PLLSetupBF()
{
    *pSIC_IWR = 0x1;
	*pPLL_CTL = SET_MSEL(VCO / CLKin);
	ssync();
	idle();
	*pPLL_DIV = SET_SSEL(VCO / SystemCLK) | ((VCO_CoreCLK)&0x30);
	asm("ssync;");
}

void CardDetection()
{
	*pPORTFIO_DIR = 0;
    *pPORTFIO_POLAR = PF7;
    *pPORTFIO_EDGE = 0;// PF7;
    *pPORTFIO_MASKA_SET = PF7;
    *pSIC_IMASK1 |= IRQ_PFA_PORTF; //Use this carefully!
    *pPORTFIO_INEN = PF7;
    
}

void SetUpDMATransmit(int NumberOfWords)
{
	*pMDMA_S0_START_ADDR = CommandBuffer[0];
    *pMDMA_S0_X_COUNT = NumberOfWords;
    *pMDMA_S0_X_MODIFY = 2;
    *pMDMA_S0_CONFIG = FLOW_STOP | 0x4;
    
    *pMDMA_D0_START_ADDR = DummyVar;
    *pMDMA_D0_X_COUNT = NumberOfWords;
    *pMDMA_D0_X_MODIFY = 2;
    *pMDMA_D0_CONFIG = FLOW_STOP | WNR | 0x4 | DI_EN;  
    
    *pMDMA_S0_CONFIG |= DMAEN;
    *pMDMA_D0_CONFIG |= DMAEN;  
}

void SetUpDMADataTransmit(int NumberOfWords)
{
	*pMDMA_S0_START_ADDR = TransmitData[0];
    *pMDMA_S0_X_COUNT = NumberOfWords;
    *pMDMA_S0_X_MODIFY = 2;
    *pMDMA_S0_CONFIG = FLOW_STOP | 0x4;
    
    *pMDMA_D0_START_ADDR = DummyVar;
    *pMDMA_D0_X_COUNT = NumberOfWords;
    *pMDMA_D0_X_MODIFY = 2;
    *pMDMA_D0_CONFIG = FLOW_STOP | WNR | 0x4 | DI_EN;  
    
    *pMDMA_S0_CONFIG |= DMAEN;
    *pMDMA_D0_CONFIG |= DMAEN;  
}

void SetUpInterruptsBF(void)
{
	*pSIC_IAR5 = 0x500600;
	register_handler(ik_ivg13,SDIsr);
	register_handler(ik_ivg12,PFIsr);
    *pSIC_IMASK1 |= 0x400;
}

void ConfigureAsyncMem(void)
{
	*pEBIU_AMBCTL1 = 0x660055C0;
	*pEBIU_AMGCTL = 0xFF;
}

void SendCommand(int Command, int value)
{
	SetUpCommandArray(Command, value);
	SetUpDMATransmit(64);
	
	while(!DMADone);
    DMADone = 0;
}

void SetUpCommandArray(int Command, int value)
{
	int temp, temp1;
    char crc;
    int i,j,a,k,xor;
    char Data;
    
    for(i=0;i<8;i++)
	{
	   for(j=0;j<8;j++)
	   {
	       CommandBuffer[i][j] = 0;
	   }
	}
    // Filling up the command buffer
    CommandBuffer[0][0] = 0xFF;
    CommandBuffer[1][0] = 0xFF;
    CommandBuffer[2][0] = 0x40 | Command;
    CommandBuffer[3][0] = (value & 0xff000000) >> 24;
	CommandBuffer[4][0] = (value & 0xff0000) >> 16;
	CommandBuffer[5][0] = (value & 0xff00) >> 8;
	CommandBuffer[6][0] = value & 0xff;
	
	// CMD0 should be 0x40 00 00 00 00 95

	    crc=0; 
		for (a=2;a<7;a++) 
		{ 
			Data=CommandBuffer[a][0]; 
			for (k=0;k<8;k++) 
			{ 
				crc <<= 1; 

				if ((Data & 0x80)^(crc & 0x80)) 
				crc ^=0x09; 
				Data <<= 1; 
			} 
		} 
		crc=(crc<<1)|1; 
		CommandBuffer[7][0] = crc;
		
			
	for(i=0;i<8;i++)
	{
	   temp = CommandBuffer[i][0]; 
	   for(j=0;j<8;j++)
	   {
	       temp1 = (temp & (1<<j));
	       if(j<4)
	       {
	           CommandBuffer[i][7-j] = 0x2F | (temp1 << (4-j));
	       }
	       if(j==4)
	       {
	           CommandBuffer[i][7-j] = 0x2F | temp1; 
	       }
	       if(j>4)
	       {
	           CommandBuffer[i][7-j] = 0x2F | (temp1 >> (j-4));
	       }
	   }
	}
}

void SetUpClockSD(int NumberOfCycles)
{
 	SetUpDMAReceive(NumberOfCycles);
 	while(!DMADone);
    DMADone = 0;
}

void SetUpDMAReceive(int NumberOfWords)
{
	*pMDMA_S0_START_ADDR = DummyVar;
    *pMDMA_S0_X_COUNT = NumberOfWords;
    *pMDMA_S0_X_MODIFY = 2;
    *pMDMA_S0_CONFIG = FLOW_STOP | 0x4;
    
    *pMDMA_D0_START_ADDR = ResponseBuffer[0];
    *pMDMA_D0_X_COUNT = NumberOfWords;
    *pMDMA_D0_X_MODIFY = 2;
    *pMDMA_D0_CONFIG = FLOW_STOP | WNR | 0x4 | DI_EN;  
    
    *pMDMA_S0_CONFIG |= DMAEN;
    *pMDMA_D0_CONFIG |= DMAEN;  
}

void SetUpDMADataReceive(int NumberOfWords)
{
	*pMDMA_S0_START_ADDR = DummyVar;
    *pMDMA_S0_X_COUNT = NumberOfWords;
    *pMDMA_S0_X_MODIFY = 2;
    *pMDMA_S0_CONFIG = FLOW_STOP | 0x4;
    
    *pMDMA_D0_START_ADDR = ReceiveData[0];
    *pMDMA_D0_X_COUNT = NumberOfWords;
    *pMDMA_D0_X_MODIFY = 2;
    *pMDMA_D0_CONFIG = FLOW_STOP | WNR | 0x4 | DI_EN;  
    
    *pMDMA_S0_CONFIG |= DMAEN;
    *pMDMA_D0_CONFIG |= DMAEN;  
}

void ReceiveResponse(int Type)
{	
	short temp = 0xFFFF;
	do 
	{
		temp = DummyVar[0];
	} while(((temp & 0x10)>>4) != 0);
	
	SetUpDMAReceive(Type);
    while(!DMADone);
    DMADone = 0;
}

void ReceiveCRC (int NumberOfWords)
{
	short temp;
	do 
	{
		temp = DummyVar[0];
		
	} while((temp & 0x1) != 0);
	
	
	
	DMADone = 0;
	SetUpDMAReceive(NumberOfWords);
    while(!DMADone);
    DMADone = 0;
   
     temp = 0;
     
    tempJ1 = DummyVar[1];  
    while((tempJ1 & 0x1) == 0)
    {	
        tempJ1 = DummyVar[1];
    }
    
    asm("nop;");
}

void ReceiveRData (int NumberOfWords)
{
	short temp = 0xFFFF;
	do 
	{
		temp = DummyVar[0];
	} while((temp & 0x1) != 0);
	
	SetUpDMADataReceive(NumberOfWords);
    while(!DMADone);
    DMADone = 0;
}

void ExtractResponse()
{
    int i,j;
    for(i=0;i<17;i++)
    {
        FinalResponseBuffer[i] = 0;
    }
    for(i=0;i<17;i++)
    {
     	for(j=0;j<8;j++)
     	{
     	    ResponseBuffer[i][j] = ResponseBuffer[i][j] & (0x10);
     	    if(j<3)
     	    {
     	        ResponseBuffer[i][j] = ResponseBuffer[i][j] << (3-j);
     	    }
     	    if(j>3)
     	    {
     	        ResponseBuffer[i][j] = ResponseBuffer[i][j] >> (j-3);   	        
     	    }
     	    FinalResponseBuffer[i] |= ResponseBuffer[i][j];
     	}   
     }    
}

void ExtractData()
{
	int i,j;
    for(i=0;i<514;i++)
    {
        FinalReceiveData[i] = 0;
    }
    for(i=0;i<514;i++)
    {
     	for(j=0;j<8;j++)
     	{
     	    ReceiveData[i][j] = ReceiveData[i][j] & (0x1);
     	    ReceiveData[i][j] = ReceiveData[i][j] << (7-j);
     	    
     	    FinalReceiveData[i] |= ReceiveData[i][j];
     	}   
     }    
}

void SetUpTransmitData()
{
	short crc, Data, temp;
	char DataIn;
	short a, b, c;
	int i, TempData;
	char j;
	
	TransmitData[0][0] = 0xFE;
        
    crc=0; 
    i=0;
	for (i=1;i<513;i++) 
	{
		for(j=0;j<8;j++)
		{
			DataIn = (TransmitData[i][0] & (1<<(7-j))) >> (7-j);
			a = (crc & 0x1)	^ DataIn;
			b = ((crc & 0x800)>>11) ^ a;
			c = ((crc & 0x10)>>4) ^ a;
			crc = crc >> 1;
			crc = crc & 0x7BF7;
			a = a << 15;
			b = b << 10;
			c = c << 3;
			crc = crc | (a & 0x8000);
			crc = crc | (b & 0x400);
			crc = crc | (c & 0x8);
		}
	}
	temp = 0;
	for(j=0;j<16;j++)
	{
		temp = temp | (((crc & (1<<j))>>j)<<(15-j));
	}
	
	TransmitData[513][0] = ((temp&0xFF00)>>8);
    TransmitData[514][0] = (temp&0xFF);
	
	for(i=0;i<515;i++)
	{
	   TempData = TransmitData[i][0]; 
	   for(j=0;j<8;j++)
	   {
	       TransmitData[i][j] = (0x3E | ((TempData & (1<<(7-j)))>>(7-j)));
	   }
	}
	TransmitData[515][0] = 0x3F;
}


EX_INTERRUPT_HANDLER (SDIsr)
{
	int temp;
	*pMDMA_D0_IRQ_STATUS |= 0x0001;
	temp = *pMDMA_D0_IRQ_STATUS;
	DMADone = 1;
	*pMDMA_S0_CONFIG = 0;
	*pMDMA_D0_CONFIG = 0;
}

EX_INTERRUPT_HANDLER (PFIsr)
{
	int tempvar;
    Debounce++;
    
    if(Debounce>2000000)
    {
    	*pSIC_IMASK &= ~IRQ_PFA_PORTF;
    	*pIMASK = 0xA01F;
    	CardDetected = 1;
    }
    tempvar = *pPORTFIO_CLEAR;
    *pPORTFIO_INEN &= ~PF8;
}




